this.name			= "oreProcessor";
this.author			= "Eric";
this.copyright		= "Creative Commons: attribution, non-commercial, sharealike.";
this.description	= "Ore processor main";
this.version		= "1.54";

this.message = new Array()
this.type = new Array()
this.quantity = new Array()
this.count = new Array()

this.startUp = function()
{
	 this.oreTimer = new Timer(this, this.processOre, 5, 0.5)
	 this.oreTimer.stop()
	 
	 this.mySound = new SoundSource;
	 this.mySound.sound = "op_process.ogg";
	 this.mySound.loop = true
}

this.addOre = function(message, type, quantity)
{
	var pos = this.message.length
	this.message[pos]=message;
	this.type[pos]=type;
	this.quantity[pos]=quantity;
	this.count[pos]=10;
	this.oreTimer.start()
	this.mySound.play()
}

this.processOre = function()
{
	if(this.count[0] > 0 && player.ship.energy > 64)
	{
		this.count[0]--
		player.ship.energy -= 6.4
	}
	else
	{
		if(this.toggle) this.toggle=false; else this.toggle = true; // to avoid identical message supression.
		if(player.ship.energy > 64)
		{
			if(player.ship.canAwardCargo(this.type[0], this.quantity[0]))
            {
                player.consoleMessage(expandDescription(this.message[0])+(this.toggle?"":" "));
                player.ship.awardCargo(this.type[0], this.quantity[0])
            }
            else
            {
                player.consoleMessage("Could not store processed goods, dumping...");
                player.ship.ejectItem("splinter");
            }
		}
		else
		{
			player.consoleMessage("Energy failure, no extraction!! 1 ton ore");
            if(player.ship.canAwardCargo("Minerals", 1))
            {
                player.ship.awardCargo("Minerals", 1)
            }
            else
            {
                player.consoleMessage("Could not store minerals, dumping...");
                player.ship.ejectItem("splinter");
            }
		}
		this.message.splice(0,1)
		this.type.splice(0,1)
		this.quantity.splice(0,1)
		this.count.splice(0,1)
		if(this.message.length==0) {this.oreTimer.stop(); this.mySound.stop();}
        else if(!player.ship.canAwardCargo(this.type[0], this.quantity[0])) this.count[0] = 2;
	}
}